/*
 * ProtoSubsys.cpp
 *
 */

#include <subsys/ProtoSubsys.h>
#include <subsys/components/DragonTalon.h>


ProtoSubsys::ProtoSubsys()
{
}

ProtoSubsys::~ProtoSubsys()
{
}

void ProtoSubsys::AddTalons
(
	std::vector<DragonTalon*>& talons	// <I> - talons to add
)
{
	for ( int inx=0; inx<talons.size(); ++inx  )
	{
		m_talons.push_back( talons[inx] );
	}
//	m_talons.insert( m_talons.begin(), talons.begin(), talons.end() );
	printf( "added talons %d \n ", m_talons.size() );
}

void ProtoSubsys::SetModes
(
	std::vector<DragonTalon::TALON_CONTROL_MODE>& modes
)
{
	for ( unsigned int inx=0; inx<m_talons.size(); ++inx )
	{
		DragonTalon* thisTalon = m_talons[inx];
	    if ( thisTalon != nullptr && inx < modes.size() )
		{
	    	printf( "Mode [ %d ] = %d \n", inx, modes[inx] );
	    	thisTalon->SetControlMode( modes[ inx ] );
		}
	}
}

void ProtoSubsys::SetTargets
(
	std::vector<double>& 	targets
)
{
	printf( "num talons %d \n ", m_talons.size() );
	for ( unsigned int inx=0; inx<m_talons.size(); ++inx )
	{
		DragonTalon* thisTalon = m_talons[inx];
		printf( " inx %d \n ", inx );
		printf( " targets.size %d \n ", targets.size() );
		printf( " is talong nullptr %s \n ", thisTalon != nullptr ? "no" : "yes" );
	    if ( thisTalon != nullptr && inx < targets.size() )
		{
	    	printf( "Target [ %d ] = %g \n", inx, targets[inx] );
	    	thisTalon->Set( targets[inx] );
		}
	}

}

void ProtoSubsys::SetCoefficients
(
	std::vector<double>& 	kP,
	std::vector<double>& 	kI,
	std::vector<double>& 	kD,
	std::vector<double>& 	kF
)
{
	for ( unsigned int inx=0; inx<m_talons.size(); ++inx )
	{
		DragonTalon* thisTalon = m_talons[inx];
	    if ( thisTalon != nullptr && inx < kP.size() )
		{
	    	thisTalon->SetClosedLoopParams( kP[inx], kI[inx], kD[inx], kF[inx] );
		}
	}
}


