/*
 * ProtoSubsys.h
 *
 */

#ifndef SRC_SUBSYS_PROTOSUBSYS_H_
#define SRC_SUBSYS_PROTOSUBSYS_H_

#include <test/ITest.h>
#include <subsys/components/DragonTalon.h>



class ProtoSubsys
{
	public:
		ProtoSubsys();
		virtual ~ProtoSubsys();

        void AddTalons
		(
			std::vector<DragonTalon*>& talons	// <I> - talons to add
		);

        void SetModes
		(
			std::vector<DragonTalon::TALON_CONTROL_MODE>& modes
		);

        void SetTargets
		(
			std::vector<double>& 	targets
		);

        void SetCoefficients
		(
			std::vector<double>& 	kP,
			std::vector<double>& 	kI,
			std::vector<double>& 	kD,
			std::vector<double>& 	kF
		);





	private:

        std::vector<DragonTalon*>						m_talons;

};


#endif /* SRC_SUBSYS_PROTOSUBSYS_H_ */
