/*
 * AnalogInputDefn.h
 */

#ifndef SRC_SUBSYS_XMLPARSING_ANALOGINPUTDEFN_H_
#define SRC_SUBSYS_XMLPARSING_ANALOGINPUTDEFN_H_
#include <subsys/components/DragonTalon.h>

#include <AnalogInput.h>

#include <thirdParty/puxixml/pugixml.hpp>

using namespace frc;

class AnalogInputDefn
{
    public:

		AnalogInputDefn() = delete;
        virtual ~AnalogInputDefn() = delete;


        //-----------------------------------------------------------------------
        // Method:      ParseXML
        // Description: Parse a analogSensor XML element and create a DragonTalon from
        //              its definition.
        // Returns:     AnalogInput*        AnalogInput (or nullptr if XML
        //                                  is ill-formed
        //-----------------------------------------------------------------------
        static AnalogInput* ParseXML
        (
            pugi::xml_node      sensorNode
        );
};

#endif /* SRC_SUBSYS_XMLPARSING_ANALOGINPUTDEFN_H_ */
