/*
 * ProtoType.h
 *
 */

#ifndef SRC_TEST_PROTOTYPE_H_
#define SRC_TEST_PROTOTYPE_H_

#include <test/ITest.h>
#include <subsys/components/DragonTalon.h>



class ProtoType: public ITest
{
	public:
		ProtoType();
		virtual ~ProtoType();


		//-----------------------------------------------------------------------
		// Method:      Init
		// Description: Initializes the prototype test.
		// Returns:     void
		//-----------------------------------------------------------------------
		void Init
		(
			ITest::ITEST_CASE_ID   test    // <I> - test case identifier
		) override;

		//-----------------------------------------------------------------------
		// Method:      Periodic
		// Description: Runs the prototype
		// Returns:     void
		//-----------------------------------------------------------------------
		void Periodic() override;

        //-----------------------------------------------------------------------------------
        // Method:          Stop
        // Description:     Stop the prototype
        // Returns:         void
        //-----------------------------------------------------------------------------------
        void Stop() override;


	private:
        void ParseXML();

        std::vector<DragonTalon::TALON_CONTROL_MODE>	m_talonModes;
        std::vector<double>								m_talonTargets;
        std::vector<double>								m_kPs;
        std::vector<double>								m_kIs;
        std::vector<double>								m_kDs;
        std::vector<double>								m_kFs;






};


#endif /* SRC_TEST_PROTOTYPE_H_ */
