/*
 * AccelerometerDefn.h
 *
 *  Created on: Aug 18, 2017
 *      Author: witcpale
 */

#ifndef SRC_DEFINITIONS_ACCELEROMETERDEFN_H_
#define SRC_DEFINITIONS_ACCELEROMETERDEFN_H_

namespace Team302
{

	class AccelerometerDefn
	{
		public:
		enum AccelerometerPort
		{
			BUILT_IN,
			I2C,
			SPI
		};
		enum AccelerometerRange
		{
			RANGE_2G,
			RANGE_4G,
			RANGE_8G,
			RANGE_16G
		};
		AccelerometerDefn() = delete;
		AccelerometerDefn
			(
				AccelerometerPort	port, 		// <I> - port the accelerometer is using
				AccelerometerRange	range		// <I> - The specification indicating its valid range
			);
			virtual ~AccelerometerDefn() = default;

			inline AccelerometerPort  GetPort()  { return m_port; }
			inline AccelerometerRange GetRange() { return m_range; }

		private:
			AccelerometerPort	m_port;
			AccelerometerRange	m_range;
	};

} /* namespace Team302 */

#endif /* SRC_DEFINITIONS_ACCELEROMETERDEFN_H_ */
