/*
 * GyroDefn.cpp
 *
 *  Created on: Aug 18, 2017
 *      Author: witcpale
 */

#include <definitions/AnalogInputDefn.h>
#include <definitions/GyroDefn.h>

namespace Team302
{

	GyroDefn::GyroDefn
	(
		int				channel, 		// <I> - analog channel
		float 			voltsPerDegree,	// <I> - Indicates how to convert from raw voltage to degrees of rotation
		float 			deadband,		// <I> - Indicates the range from center to ignore (volts)
		float 			center,			// <I> - Indicates the preset uncalibrated value to use as the accumulator center
		float 			offset,			// <I> - Indicates the preset uncalibrated value to use as the gyro offset
		float 			sensitivity		// <I> - Indicates the sensitivity (volts/degree/second) from the data sheet
	) : AnalogInputDefn( channel , voltsPerDegree ),
		m_deadband( deadband ),
		m_center( center ),
		m_offset( offset ),
		m_sensitivity( sensitivity )
	{
	}

} /* namespace Team302 */
