/*
 * NavXDefn.h
 *
 *  Created on: Aug 18, 2017
 *      Author: witcpale
 */

#ifndef SRC_DEFINITIONS_NAVXDEFN_H_
#define SRC_DEFINITIONS_NAVXDEFN_H_

namespace Team302
{

	class NavXDefn
	{
		public:
			enum NavXPort
			{
				I2C,
				SPI,
				SERIAL
			};
			NavXDefn() = delete;
			NavXDefn
			(
				NavXPort		port, 				// <I> - port it is plugged into
				int 			updateRate			// <I> - channel on the PCM that the solenoid is plugged into
			);
			virtual ~NavXDefn() = default;

			inline NavXPort GetPort() { return m_port; }
			inline int GetUpdateRate() { return m_updateRate; }

		private:
			NavXPort				m_port;
			int						m_updateRate;

	};

} /* namespace Team302 */

#endif /* SRC_DEFINITIONS_NAVXDEFN_H_ */
